# -*- coding:UTF-8 -*-
from PIL import Image
import os
import random

def image_split(original_path,species,stardand_path,set,inds):
    for img in inds:
        # 以原始路径+植物名字+序列号为图片路径打开图片
        plant_path=os.path.join(original_path, species, img)
        in_img=Image.open(plant_path)
        out_img = in_img.resize((224,224))
        # 以原始路径+集名+植物名字为该文件集路径
        set_path=os.path.join(stardand_path, set, species)
        if not os.path.exists(set_path):
            os.makedirs(set_path)
        out_img.save(os.path.join(set_path,img))

def main():
    #读取图片：Artemisia indica五月艾，Chinese rose月季花，Lobular boxwood小叶黄杨，
    #deodar雪松，Chinese pennisetum狼尾草
    original_path = './dataset/bjfu_plants' #图片原始路径
    stardand_path = './PlantsData' #图片分集后的路径
    for species in os.listdir(original_path):
        files = sorted(os.listdir(os.path.join(original_path,species)))
        img_num=len(files)
        test_num=int (img_num/10*2) #测试数量
        valid_num=int ((img_num-test_num)/10*2) #验证数量
        train_num=int(img_num-test_num-valid_num) #训练数量
        print('%s: %d, train: %d, valid: %d, test: %d'%(species,img_num,train_num,valid_num,test_num))

        random.shuffle(files)   #打乱图片顺序
        image_split(original_path,species,stardand_path,'train',files[0:train_num])
        print("%s finish!"% os.path.join(stardand_path,'train',species))
        image_split(original_path, species, stardand_path, 'valid', files[train_num:train_num+valid_num])
        print("%s finish!" % os.path.join(stardand_path, 'valid', species))
        image_split(original_path, species, stardand_path, 'test', files[train_num+valid_num:])
        print("%s finish!" % os.path.join(stardand_path, 'test', species))

if __name__=='__main__':
    main()
