# -*- coding: UTF-8 -*-
import os
import time
import tensorflow as tf

species_num = 5
learning_rate = 0.00005
batch_size = 16
nb_epoch = 30
data_path = '../data'


def main(path):
    # species = ['五月艾', '小叶黄杨', '月季花', '狼尾草', '雪松']
    train_path = 'dataset/bjfu_plants'
    species = []
    for spe in sorted(os.listdir(train_path)):
        species.append(spe)
    print(species)
    init_model = tf.keras.applications.mobilenet.MobileNet(input_shape=(224, 224, 3),
                                                           include_top=False, pooling='avg')
    x = tf.keras.layers.Dense(128, activation='relu')(init_model.output)
    output = tf.keras.layers.Dense(species_num, activation='softmax')(x)
    model = tf.keras.Model(inputs=init_model.input, outputs=output)
    model.load_weights('./models/checkpoints/model')

    image = tf.cast(tf.image.decode_image(tf.read_file(path)),
                    dtype=tf.float32) / tf.constant(255, dtype=tf.float32)
    image_decoded = tf.expand_dims(image, axis=0)
    start = time.time()
    result = model.predict(image_decoded, steps=1)[0]
    print ('Evaluation time for 1 image: %0.2f s' % (time.time() - start))
    for specie, conf in zip(species, result):
        print ('\t%s: %0.4f' % (specie, conf))


if __name__ == '__main__':
    img_path = 'PlantsData/test/Chinese rose/2018-08-28-17-41-48.jpg'
    # img_path = 'PlantsData/test/Chinese rose/2018-08-28-17-41-46.jpg'
    main(img_path)
