import tensorflow as tf

species_num = 5
tf.keras.backend.set_learning_phase(0)

init_model = tf.keras.applications.mobilenet.MobileNet(input_shape=(224, 224, 3),
                                                       include_top=False, pooling='avg')
x = tf.keras.layers.Dense(512, activation='relu')(init_model.output)
output = tf.keras.layers.Dense(species_num, activation='softmax')(x)
model = tf.keras.Model(inputs=init_model.input, outputs=output)
model.load_weights('./models/checkpoints/model')

from tensorflow.python.framework import graph_util
from tensorflow.python.framework import graph_io
sess = tf.keras.backend.get_session()
constant_graph = graph_util.convert_variables_to_constants(sess, sess.graph.as_graph_def(),
                                                           [model.outputs[0].name.split(':')[0]])
graph_io.write_graph(constant_graph, './models/checkpoints/', 'model.pb', as_text=False)
print(constant_graph)

# pred = [None]
# pred_node_names = [None]
#
# pred_node_names[0] = 'output_node'
# pred[0] = tf.identity(model.outputs[0], name=pred_node_names[0])
# print('output nodes names are: ', pred_node_names)
#
# sess = tf.keras.backend.get_session()
#
# tf.train.write_graph(sess.graph.as_graph_def(), 'bin/models/xx', 'model.pbtxt', as_text=True)
#
# from tensorflow.python.framework import graph_util
# from tensorflow.python.framework import graph_io
# constant_graph = graph_util.convert_variables_to_constants(sess, sess.graph.as_graph_def(), pred_node_names)
# graph_io.write_graph(constant_graph, 'bin/models/xx', 'model.pb', as_text=False)
